function [Pxx,w] = pgram(x, window, overlap, NFFT)

    x = x(:);
    window = window(:);

    % Laenge meiner Daten
    Q = length(x);

    % Laenge eines Datensamples
    L = length(window);
    
    % Laenge der FFT: reelles Signal --> einseitiges Spektrum
    FtL = floor(NFFT/2+1);
    
    % Alle "stepsize" Samples berechne ein Fenster mit Laenge L
    stepsize = L - overlap;
    
    % Entnormalisierung des Fensters
    U = sum(abs(window).^2)/L;
    
    Pxx = zeros(FtL,1);
    
    K=0;
    for i=1:stepsize:Q
        if i+L-1 <= Q
            xr = x(i:i+L-1);
        %else
        %    xr = x(i:end);
        %    
        %    % Wenn letzter Block nicht reinpasst: Zeropadding
        %    xr = [xr ; zeros(L-length(xr),1)];            
        %end
        
        xr = xr .* window;
        
        Pr = (abs(fft(xr, NFFT)).^2)/(U*L);
        
        Pxx = Pxx + Pr(1:FtL);
        
        K = K + 1;
        end
    end
    
    % Diese PSD ist *ein*seitig. Die Energie im Spektrum teilt sich
    % allerdings auf das ganze Spektrum auf. Damit die Energie trotzdem
    % gleich bleibt, wird das einseitige Spektrum verdoppelt:
    Pxx = 2*(Pxx/K);

    % Die Verdoppelung beim ersten Sample rckgngig machen, da der
    % Gleichanteil sowohl bei onesided als auch twosided enthalten ist
    Pxx(1) = Pxx(1)/2;
    
    % Wenn Laenge gerade ist, kommt Mittelpixel ebenfalls in
    % onesided/twosided vor
    if mod(NFFT,2) == 0
      % Es existiert ein symmetrischer Mittelpixel
      Pxx(end) = Pxx(end)/2;
    end
    
    w = linspace(0, pi, FtL);
    
    
    
    
    
    
    
    
    
    
    
    