clear all;
close all;

x = load('lda.txt');

fa = 2.5 * 10^6;

% Zweierpotenzen
windows = [1024 256 128 32];

figure;
i = 1;
for wnds=windows
  % je mehr Mittelungen, desto glatter
  
  % @hamming: Schlechte Frequenzauflsung: Hauptkeulen sehr weit
  %           Gut bei Leakage: Wenig parasitre Frequenzen neben unseren
  %           Hauptpeaks
  
  % @rectwin: Gute Frequenzauflsung: Unsere Frequenz wird genau getroffen
  %           (spitz)
  %           Leakage: schlecht. Vor allem bei wenig Mittelungen sind
  %           Leakage peaks schwer von Signalpeak zu trennen
  
  wnd = window(@hamming, wnds);
  
  %overlap = floor(wnds/2);
  overlap = 0;
  
  [Pxx,w] = pgram(x, wnd, overlap, wnds);
  %[Pxx,w] = pwelch(x, wnd, overlap, wnds);
  
  
  subplot(2,2,i);
  plot(((w/(2*pi))*fa)/1000, 10*log10(Pxx));
  title(['Windowsize: ', int2str(wnds), ', Overlap: ', int2str(overlap)]);
  grid on;
  xlabel 'Frequenz [kHz]';
  i=i+1;
end


[B,A] = ellip(8, 1, 40, 88e-3, 'high');

xf = filter(B, A, x);


figure;
i = 1;
for wnds=windows
   wnd = window(@hamming, wnds);
   
   %overlap = floor(wnds/2);
   overlap = 0;
   
   [Pxx,w] = pgram(xf, wnd, overlap, wnds);
   
   subplot(2,2,i);
   plot(((w/(2*pi))*fa)/1000, 10*log10(Pxx));
   title(['Windowsize: ', int2str(wnds), ', Overlap: ', int2str(overlap)]);
   grid on;
   xlabel 'Frequenz [kHz]';
   i=i+1;
end


wnd = window(@rectwin, 256);
[Pxx,w] = pgram(xf, wnd, 128, 256);

[Y,I] = max(Pxx);

fd = I*(fa/2)/length(Pxx);

fd

theta = pi/6;

lambda = 632 * 10^-9;

d = lambda/(2*sin(theta/2));

v = fd * d;

v














